#include "ruledebuggerImpl.h"
#include <iostream>

RuleDebuggerImpl::RuleDebuggerImpl(const std::string filename, QWidget* parent, const char* name, WFlags fl )
     : RuleDebugger(parent, name, fl) {
     bs = new BufferedSettings(filename);
     wl = new Wordlist(*bs);
}

void RuleDebuggerImpl::slotMatchClick() {
     if (ComboBox1->currentText() != "") {
	  LineEdit6->setText(ComboBox1->currentText());
     }
     else {
	  if (LineEdit1->text() == "") return;
	  LineEdit6->setText(LineEdit1->text());
     }
     if (ComboBox2->currentText() != "") {
	  LineEdit6->setText(LineEdit6->text() + " " + ComboBox2->currentText());
     }
     else {
	  if (LineEdit2->text() == "") return;
	  LineEdit6->setText(LineEdit6->text() + " " + LineEdit2->text());
     }
     if (ComboBox3->currentText() != "") {
	  LineEdit6->setText(LineEdit6->text() + " " + ComboBox3->currentText());
     }
     else {
	  if (LineEdit3->text() == "") return;
	  LineEdit6->setText(LineEdit6->text() + " " + LineEdit3->text());
     }
     if (ComboBox4->currentText() != "") {
	  LineEdit6->setText(LineEdit6->text() + " " + ComboBox4->currentText());
     }
     else {
	  if (LineEdit4->text() == "") return;
	  LineEdit6->setText(LineEdit6->text() + " " + LineEdit4->text());
     }
     if (ComboBox5->currentText() != "") {
	  LineEdit6->setText(LineEdit6->text() + " " + ComboBox5->currentText());
     }
     else {
	  if (LineEdit5->text() == "") return;
	  LineEdit6->setText(LineEdit6->text() + " " + LineEdit5->text());
     }
}

void RuleDebuggerImpl::slotToClick() {
     if (ComboBox1->currentText() != "") {
	  LineEdit7->setText(ComboBox1->currentText());
     }
     else {
	  if (LineEdit1->text() == "") return;
	  LineEdit7->setText(LineEdit1->text());
     }
     if (ComboBox2->currentText() != "") {
	  LineEdit7->setText(LineEdit7->text() + " " + ComboBox2->currentText());
     }
     else {
	  if (LineEdit2->text() == "") return;
	  LineEdit7->setText(LineEdit7->text() + " " + LineEdit2->text());
     }
     if (ComboBox3->currentText() != "") {
	  LineEdit7->setText(LineEdit7->text() + " " + ComboBox3->currentText());
     }
     else {
	  if (LineEdit3->text() == "") return;
	  LineEdit7->setText(LineEdit7->text() + " " + LineEdit3->text());
     }
     if (ComboBox4->currentText() != "") {
	  LineEdit7->setText(LineEdit7->text() + " " + ComboBox4->currentText());
     }
     else {
	  if (LineEdit4->text() == "") return;
	  LineEdit7->setText(LineEdit7->text() + " " + LineEdit4->text());
     }
     if (ComboBox5->currentText() != "") {
	  LineEdit7->setText(LineEdit7->text() + " " + ComboBox5->currentText());
     }
     else {
	  if (LineEdit5->text() == "") return;
	  LineEdit7->setText(LineEdit7->text() + " " + LineEdit5->text());
     }
}

void RuleDebuggerImpl::slotClearClick() {
     LineEdit1->clear();
     LineEdit2->clear();
     LineEdit3->clear();
     LineEdit4->clear();
     LineEdit5->clear();
     ComboBox1->clear();
     ComboBox2->clear();
     ComboBox3->clear();
     ComboBox4->clear();
     ComboBox5->clear();
}

void RuleDebuggerImpl::slotPrintClick() {
     QString ex;
     if (LineEdit1->text() != "") ex += LineEdit1->text();
     if (LineEdit2->text() != "") ex += " " + LineEdit2->text();
     if (LineEdit3->text() != "") ex += " " + LineEdit3->text();
     if (LineEdit4->text() != "") ex += " " + LineEdit4->text();
     if (LineEdit5->text() != "") ex += " " + LineEdit5->text();
     ex += " - " + LineEdit9->text();
     std::cerr << "\n<rule ex=\"" << ex << "\">\n"
	       << "  <match>" << LineEdit6->text() << "</match>\n"
	       << "  <to>" << LineEdit7->text() << "</to>\n"
	       << "  <order>" << LineEdit8->text() << "</order>\n"
	       << "</rule>\n\n";
}

void RuleDebuggerImpl::slotApplyClick() {
     std::list<WordTag> listwt;
     if (LineEdit1->text() != "") {
	  listwt.push_back(WordTag(LineEdit1->text().latin1(), wl->untag(ComboBox1->currentText().latin1()), 1, "", 1, 1));
     }
     if (LineEdit2->text() != "") {
	  listwt.push_back(WordTag(LineEdit2->text().latin1(), wl->untag(ComboBox2->currentText().latin1()), 2, "", 1, 2));
     }
     if (LineEdit3->text() != "") {
	  listwt.push_back(WordTag(LineEdit3->text().latin1(), wl->untag(ComboBox3->currentText().latin1()), 3, "", 1, 3));
     }
     if (LineEdit4->text() != "") {
	  listwt.push_back(WordTag(LineEdit4->text().latin1(), wl->untag(ComboBox4->currentText().latin1()), 4, "", 1, 4));
     }
     if (LineEdit5->text() != "") {
	  listwt.push_back(WordTag(LineEdit5->text().latin1(), wl->untag(ComboBox5->currentText().latin1()), 5, "", 1, 5));
     }
     if (listwt.empty()) {
	  return;
     }
     bool ret = applyHelper(LineEdit6->text().latin1(), LineEdit7->text().latin1(), LineEdit8->text().latin1(), listwt);
     if (ret) {
	  LineEdit9->clear();
	  LineEdit10->clear();
	  for (std::list<WordTag>::const_iterator iter = listwt.begin(); iter != listwt.end(); ++iter) {
	       LineEdit9->setText(LineEdit9->text() + " " + iter->word().c_str());
	       LineEdit10->setText(LineEdit10->text() + " " + wl->tag(iter->tag()).c_str());
	  }
	  LineEdit9->setText(LineEdit9->text().stripWhiteSpace());
	  LineEdit10->setText(LineEdit10->text().stripWhiteSpace());
	  qDebug("JA");
     }
     else {
	  LineEdit9->setText("Input did not match");
	  LineEdit10->setText("Input did not match");
	  qDebug("NEJ");
     }
}

void RuleDebuggerImpl::slotWidget1(const QString& str) {
     ComboBox1->clear();
     Wordlist::const_iterator iter_last = wl->findLastWord(str.latin1());
     for (Wordlist::const_iterator iter = wl->findFirstWord(str.latin1());
	  iter != iter_last; ++iter) {
	  ComboBox1->insertItem(QString::fromLatin1(wl->tag(iter->tag()).c_str()));
     }     
}

void RuleDebuggerImpl::slotWidget2(const QString& str) {
     ComboBox2->clear();
     Wordlist::const_iterator iter_last = wl->findLastWord(str.latin1());
     for (Wordlist::const_iterator iter = wl->findFirstWord(str.latin1());
	  iter != iter_last; ++iter) {
	  ComboBox2->insertItem(QString::fromLatin1(wl->tag(iter->tag()).c_str()));
     } 
}

void RuleDebuggerImpl::slotWidget3(const QString& str) {
     ComboBox3->clear();
     Wordlist::const_iterator iter_last = wl->findLastWord(str.latin1());
     for (Wordlist::const_iterator iter = wl->findFirstWord(str.latin1());
	  iter != iter_last; ++iter) {
	  ComboBox3->insertItem(QString::fromLatin1(wl->tag(iter->tag()).c_str()));
     } 
}

void RuleDebuggerImpl::slotWidget4(const QString& str) {
     ComboBox4->clear();
     Wordlist::const_iterator iter_last = wl->findLastWord(str.latin1());
     for (Wordlist::const_iterator iter = wl->findFirstWord(str.latin1());
	  iter != iter_last; ++iter) {
	  ComboBox4->insertItem(QString::fromLatin1(wl->tag(iter->tag()).c_str()));
     } 
}

void RuleDebuggerImpl::slotWidget5(const QString& str) {
     ComboBox5->clear();
     Wordlist::const_iterator iter_last = wl->findLastWord(str.latin1());
     for (Wordlist::const_iterator iter = wl->findFirstWord(str.latin1());
	  iter != iter_last; ++iter) {
	  ComboBox5->insertItem(QString::fromLatin1(wl->tag(iter->tag()).c_str()));
     } 
}

std::list<WordTag> RuleDebuggerImpl::reorder(const std::list<WordTag>& lwt, const std::string& order) const {
     std::list<WordTag> ret;
     try {
	  std::vector<WordTag> v_to;
	  for (std::list<WordTag>::const_iterator iter = lwt.begin(); iter != lwt.end(); ++iter) {
	       v_to.push_back(*iter);
	  }
	  unsigned int count = 0;
	  for (std::string::const_iterator iter = order.begin(); iter != order.end(); ++iter) {
	       ret.push_back(v_to.at(boost::lexical_cast<int>(*iter) - 1));
	       ++count;
	  }
	  for (unsigned int i = count; i < v_to.size(); ++i) {
	       ret.push_back(v_to.at(i));
	  }
     }
     catch (boost::bad_lexical_cast &) {
	  std::cerr << "Warning: <order> element must only contain numbers\n";
	  ret = lwt;
     }
     catch (const std::out_of_range &) {
	  std::cerr << "Warning: to big number in <order> element\n";
	  ret = lwt;
     }
     return ret;
}

std::string RuleDebuggerImpl::replaceMatchedExpressions(const std::string& exp, const boost::match_results<std::string::const_iterator> &result) const {
     std::string ret = exp;
     std::string::size_type index = ret.find('@', 0);
     try {
	  while (index != std::string::npos) {
	       unsigned int param = boost::lexical_cast<unsigned int>(ret.at(index + 1));
	       if (param >= 1 && param <= result.size() - 1) {
		    ret.replace(index, 2, result[param]);
	       }
	       else {
		    throw std::out_of_range("index in <to> element to big");
	       }
	       index = ret.find('@', index);
	  }
     }
     catch (const boost::bad_lexical_cast &) {
	  std::cerr << "Error: " << '@' << " must be followed by a number\n";
     }
     catch (const std::out_of_range &e) {
	  std::cerr << "Error: out of range: " << e.what() << "\n";
     }
     return ret;
}

bool RuleDebuggerImpl::applyHelper(const std::string& match, const std::string& to, const std::string& order, std::list<WordTag>& listwt) const {
     if (match.length() == 0 || to.length() == 0 || order.length() == 0) {
	  return false;
     }

     boost::regex expression;
     boost::match_results<std::string::const_iterator> result;
     Separator sep(" ");
     std::string toMatch;
     try {
	  // Parse the <match>-tag and format the input
	  // string in the corresponding way
	  Tokenizer token(match, sep);
	  std::list<WordTag>::const_iterator listPos = listwt.begin();
	  for (Tokenizer::const_iterator itok = token.begin();
	       itok != token.end(); ++itok) {
	       if (listPos == listwt.end()) {
		    throw EndOfInputException();
	       }
	       if ((*itok)[0] == '\'') { // literal word
		    toMatch += '\'' + listPos->word() + '\'' + " ";
	       }
	       else { // word tag
		    toMatch += wl->tag(listPos->tag()) + " ";
	       }
	       ++listPos;	       
	  }
	  // Match the input string with the <match>-tag
	  toMatch = toMatch.substr(0, toMatch.length() - 1);
	  std::cerr << "toMatch: '" << toMatch << "'\n";
	  expression.set_expression(match, boost::regbase::normal);
	  if (regex_match(toMatch, result, expression)) {
	       // Transform according to the <to>-tag
	       std::string newMatch = replaceMatchedExpressions(to, result);
	       std::cerr << "New string is: " << newMatch << "\n";
	       // Tokenize the new string register the changes that was made
	       Tokenizer newToken(newMatch, sep);
	       std::list<WordTag>::iterator listPos = listwt.begin();
	       for (Tokenizer::const_iterator itok = newToken.begin();
		    itok != newToken.end(); ++itok) {
		    if (listPos == listwt.end()) {
			 throw EndOfInputException();
		    }
		    std::cerr << "Current token: " << *itok << "\n";
		    if ((*itok)[0] == '\'') {
			 // This is a literal word
			 std::cerr << "Literal word\n";
			 std::string newword = (*itok).substr(1, (*itok).length() - 2);
			 std::string oldword = listPos->word();
			 if (newword != oldword) {
			      // Select a new tag for the word. Use same if possible
			      int oldtag = listPos->tag();
			      listPos->set(newword, wl->getTag(newword, oldtag));
			 }
		    }
		    else {
			 // This is a word tag
			 if (*itok != wl->tag(listPos->tag())) {
			      // The tag changed
			      try {
				   // Try to change the word and tag. If this can't be done,
				   // no changes are made
				   std::string oldword = listPos->word();
				   int oldtag = listPos->tag();
				   int newtag = wl->untag(*itok);
				   std::string lemma = wl->findLemma(oldword, oldtag);
				   std::string newword = wl->findWord(lemma, newtag);
				   listPos->set(newword, newtag);
			      }
			      catch (const NotFoundException &e) {
				   std::cerr << "Warning: " << e.what()
					     << ". No change done." << std::endl;
				   return false;
			      }
			 }
			 else {
			      // The tag did not change
			      std::cerr << "no tag change\n";
			 }
		    }
		    ++listPos;		    
	       }
	       // Whan all changes are made. Reorder the WordTags according to
	       // the <order>-tag.
	       listwt = reorder(listwt, order);
	       return true;
	  }
     }
     catch (EndOfInputException &) {
	  std::cerr << "End of input. No match even possible for this rule\n";
     }
     return false;
}
