#ifndef RULEDEBUGGERIMPL_H
#define RULEDEBUGGERIMPL_H

#include <list>

#include <qcombobox.h>
#include <qlineedit.h>

#include "ruledebugger.h"

#include <boost/regex.hpp>
#include <boost/lexical_cast.hpp>
#include <boost/tokenizer.hpp>

#include "bufferedsettings.hpp"
#include "wordlist.hpp"
#include "wordtag.hpp"

class RuleDebuggerImpl : public RuleDebugger {
     Q_OBJECT
public:
     RuleDebuggerImpl(const std::string filename, QWidget* parent = 0, const char* name = 0,
		      WFlags f = 0);
     ~RuleDebuggerImpl() {}
 private:
     typedef boost::char_separator<char> Separator;
     typedef boost::tokenizer<Separator> Tokenizer;
     
     std::list<WordTag> reorder(const std::list<WordTag>&, const std::string&) const;
     bool applyHelper(const std::string&, const std::string&, const std::string&, std::list<WordTag>&) const;
     std::string replaceMatchedExpressions(const std::string&, const boost::match_results<std::string::const_iterator> &) const;

     BufferedSettings *bs;
     Wordlist *wl;

 public slots:
     virtual void slotMatchClick();
     virtual void slotToClick();
     virtual void slotClearClick();
     virtual void slotPrintClick();
     virtual void slotApplyClick();
     virtual void slotWidget1(const QString&);
     virtual void slotWidget2(const QString&);
     virtual void slotWidget3(const QString&);
     virtual void slotWidget4(const QString&);
     virtual void slotWidget5(const QString&);
};

#endif

