/******************************************************************************

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

******************************************************************************/

#include <iostream>
#include <iomanip>
#include <fstream>

#include "dynamic.hpp"

extern "C" {
#include <zlib.h>
}

int main(int argc, char *argv[]) {
    if (argc != 2) {
        std::cerr << "Usage: " << argv[0] << "\tinfile\n";
        std::exit(1);
    }
    gzFile input = gzopen(argv[1], "rb");
    if (!input) {
        std::cerr << "Can't open file\n";
        std::exit(1);
    }
    int length;
    gzread(input, &length, sizeof(length));
    for (int i = 0; i < length * 2; i++) {
        Corpus::WordToken wt;
        gzread(input, &wt, sizeof(Corpus::WordToken));
        std::string word("");
        std::string lemma("");
        for (int j = 0; j < 8; j++) {
            lemma.push_back(wt.t2.data[j]);
            word.push_back(wt.t3.data[j]);
        }
        if (i == length) {
            std::cout << "----------\n";
        }
        std::cout << std::setw(3) << i << "  " << std::setw(10) << word
                  << "\t       " << lemma
                  << "\t     " << wt.data()
                  << "\n";
    }
    return 0;
}
