/******************************************************************************

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

******************************************************************************/

#ifndef SIMPLESETTINGS_H
#define SIMPLESETTINGS_H

#include "settings.hpp"

/**
 * The SimpleSettings class does not cache any data, the data
 * is read from the DOM-tree each time.
 */
class SimpleSettings : public Settings {
public:
     SimpleSettings(const std::string&);
     virtual ~SimpleSettings();
     virtual std::set<std::string> allParameters(const std::string&, const std::string&) const;
protected:
     virtual std::string parameterValue(const std::string&) const throw(ParamNotFoundException);
};

#endif
